/* *************************************************************************

   Program:   NPL
   File:      CalcLikRatio.c
   Author:    Zachary Skrivanek 
   Date:      April 1, 2000 
   Purpose:   Calcs the likelihood ratio at a point for a single pedigree. 
   Modified:  April 26, 2001 Both the den and num were suffering from
	      numerical underflow with large pedigrees when I calculated
	      them separately and then later took the ratio.  So I modified
	      this to calculate the ratio and take the product over each 
	      meiosis.

************************************************************************* */
#include "simple.h"
#include <stdio.h>

#define  F 0
#define  M 1
#define FOUNDER 0
#define AFFECTED 2

double CalcLikRatio(int    **ancestry,
		    int    pedigreesize,
		    aff    *affected,
		    int    **IBDsim,
                    int    **disIV, 
	            double *prob,
                    double *likprob,
                    int    nmarkers)
{
  int    i,f,m;
  /* double num=1.0,den=1.0,dnum; */
  double num, den, dnum=1.0;
  int    power();


  for(i=0; i<pedigreesize; i++) 
    if(!ancestry[i][FOUNDER]){ /* 7/4/02 Zak */
/*      if(affected[i].status==AFFECTED){  */
        f = IBDsim[i][F]+disIV[i][F]*power(3,nmarkers);
        m = IBDsim[i][M]+disIV[i][M]*power(3,nmarkers);
        /* den *= (prob[f] * prob[m]); */
        den = (prob[f] * prob[m]);
        /* num *= (likprob[f] * likprob[m]); */
        num = (likprob[f] * likprob[m]);
      /* these two lines are new */
        if(den <= 0.0) return(0.0);
        else dnum *= num/den;
    } 

  return(dnum);
/*
  if(den > 0.0) dnum = num/den;
    else dnum = 0.0;
  return(dnum);*/
}
   


