/* ********************************************************************

   Program:  NPL (Non-Parametric Linkage)
   File:     NPL.c
   Author:   Zachary Skrivanek
   Date:     March 23, 2000
   Purpose:  Calculate NPL-all for a single pedigree.

********************************************************************* */

#define TRUE 1

double CalcScoreAll(int     **s,
                    int     naffected,
		    int     *a,
		    int     *bit,
		    int     *seen,
		    int     *num)
{

  int    choices, i, j;
  int    score=0;
  int    power();

  choices = power(2,naffected);

  for(i=0; i<choices; ++i)
  {
    for(j=0; j<naffected; ++j) bit[j] = (i >> j) %2;
    for(j=0; j<naffected; ++j) a[j] = s[j][bit[j]];
    score += h(a,naffected,seen,num);
  }
  return (double) score/ (double) choices;

}

int h(int *all, int naffected, int *seen, int *num)
{
  int i, k, cnt, flg, perms;


  cnt = 0;
  for (i=0; i<naffected; ++i)
  {
    k=0;
    flg = 1;
    while (k < cnt)
    {
      if (all[i] == seen[k])
      {
        flg =0;
        ++num[k];
      }
      ++k;

    }
    if (flg)
    {
      seen[cnt] = all[i];
      num[cnt] = 1;
      ++cnt;
    }
  }
  perms = 1;
  for (i=0; i<cnt; ++i)
    for (k=1; k<=num[i]; ++k)
      perms *= k;

  return perms-1;

}
