#include <stdio.h>
#include "simple.h"

#define dd 0
#define dD 1
#define Dd 2
#define DD 3
#define PID 0
#define UNKNOWN 0 
#define NOT_AFFECTED 1 
#define AFFECTED 2 

int    i,j;
 
void CreateDiseasePrePPots(double ****ppotential,
			   aff    **affected,
			   double **liability,
                           int    nloci,
                           int    npedigrees,
		           int    *pedigreesize,
		           int    ***pedigree)
                      
{

  aff    *p;

  for(i=0; i < npedigrees; i++) 
    for(j=0; j < pedigreesize[i]; j++) {
      p = &affected[i][j];  /* for reading ease */
      if(p->status==AFFECTED){
        ppotential[i][j][nloci-1][dd] = liability[p->class-1][0]; 
        ppotential[i][j][nloci-1][dD] = liability[p->class-1][1]; 
        ppotential[i][j][nloci-1][Dd] = liability[p->class-1][1]; 
        ppotential[i][j][nloci-1][DD] = liability[p->class-1][2]; 
      }
      else if(p->status==NOT_AFFECTED){
        ppotential[i][j][nloci-1][dd] = 1-liability[p->class-1][0]; 
        ppotential[i][j][nloci-1][dD] = 1-liability[p->class-1][1]; 
        ppotential[i][j][nloci-1][Dd] = 1-liability[p->class-1][1]; 
        ppotential[i][j][nloci-1][DD] = 1-liability[p->class-1][2]; 
      }
      else if(p->status==UNKNOWN){
        ppotential[i][j][nloci-1][dd] = 1.0;
        ppotential[i][j][nloci-1][dD] = 1.0;
        ppotential[i][j][nloci-1][Dd] = 1.0;
        ppotential[i][j][nloci-1][DD] = 1.0;
      }
      else {
	fprintf(stderr,"pedigree %d person %d: status %d undefined",i+1,j+1,p->status);
	nerror("Ped File format error!");
      }
    }
}


void DebugReadDiseasePrePPots(int    npedigrees,
		              int    *pedigreesize,
		              int    ***pedigree,
			      int    nloci,
			      double *disaf,
		              double ****ppotential)
{
  char response[2];

  printf("\n\nDebug ReadPrePPots()? => ");
  scanf("%s",response);
  if( strcmp(response,"q") == 0 ) return;
  if( strcmp(response,"y") == 0 ) {
    

    printf("\n\n");
    printf("P[normal] = %le, P[mutant] = %le\n",disaf[0],disaf[1]);

    printf("\n\n");
    for(i=0; i < npedigrees; i++) {
      printf("Pre-Point Potentials for Pedigree #%d",i+1);
      printf("\n\n");
      printf("PersonID   f(.|dd)   f(.|dD)   f(.|Dd)   f(.|DD)");
      printf("\n");
      printf("--------   -------   -------   ------    -------");
      for(j=0; j < pedigreesize[i]; j++) {
	printf("\n");
	printf("%8d  %8.2le  %8.2le  %8.2le  %8.2le",
	       pedigree[i][j][PID],
	       ppotential[i][j][nloci-1][dd],ppotential[i][j][nloci-1][dD],
	       ppotential[i][j][nloci-1][Dd],ppotential[i][j][nloci-1][DD]);
      }
    }
    printf("\n\n");
  }
}

