/* *********************************************************************

   Program:   SIMPLE
   File:      DumpHaps.c
   Author:    Zachary Skrivanek 
   Date:      April 29, 2002
   Purpose:   Dump the simulated haplotypes.  These are dumped as:  
	      F1 M1  F2 M2  F3 M3 ... Fn Mn for n pedigree members,
	      where F#, M# are the paternal and maternal haplotypes for
	      pedigree member #

********************************************************************* */
#include "simple.h"



void DumpHaps(int  npedigrees,
	      int  *pedigreesize,
              int  ****simhap,
	      int  nmarkers,
	      int  *nalleles,
	      int  *hap)
{

  count   ped,i,marker,parent;
  int     unmulti_base();
  int     HAP;

  for(ped=0; ped<npedigrees; ped++)
    for(i=0; i<pedigreesize[ped]; i++){
      for(parent=0; parent<2; parent++){
        for(marker=0; marker<nmarkers; marker++) 
	/* get haplotypes and put in correct order */
	  hap[marker]=simhap[ped][i][marker][parent]-1;
        HAP = unmulti_base(nmarkers,nalleles,hap);
	printf("%d ",HAP);
      }
      printf(" ");
    }
}


