/***************************************************************

  Program: scan 
  File:    DumpPairs.c
  Author:  Zachary Skrivanek 
  Date:    July 18, 2002
  Purpose: Print out expected value of alleles shared IBD.

***************************************************************/

#include "simple.h"


int    i, j, ped, pair, type; /* index variables */

void  DumpPairs(double ******IBDprob,
		int    npedigrees,
		int    *npairs,
		double **location,
		int    *numlik,
		prs    ***pairs,
		cmd    c){

  double  EV, CalcEV();
  int ntypes;


  if(c.type.par==3) ntypes=2;
  else ntypes=1;

  printf("===========================\n");
  printf("Expected alleles shared IBD\n");
  printf("===========================\n");
  for(ped=0; ped < npedigrees; ped++){
    printf("pedigree %3d\n",ped+1);
    /* print out pairs */
    printf("pair: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pair+1);
    printf("\n");
    printf("mem1: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pairs[ntypes-1][ped][pair].pid[0]);
    printf("\n");
    printf("mem2: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pairs[ntypes-1][ped][pair].pid[1]);
    printf("\n");
    for(i=1; i < c.file.nmodels; i++)
      for(j=0; j < numlik[i]; j++){
        printf("%5.2lf ", 100*location[i][j]);
        for(pair=0; pair<npairs[ped]; pair++) {
	  EV=CalcEV(&IBDprob[i-1][j][ntypes-1][ped][pair][0]);
	  printf("%le ", EV);
        }
	printf("\n");
      }
  }

} 


double  CalcEV(double  *p){

  double  EV;
   
  EV = p[1] + 2*p[2];

  return(EV);

}
