/***************************************************************

  Program: scan 
  File:    DumpIBDProbs.c
  Author:  Zachary Skrivanek 
  Date:    November 27, 2002 
  Purpose: Print out pairwise IBD probs.

***************************************************************/

#include "simple.h"


int    i, j, ibd, ped, pair, type; /* index variables */

void  DumpProbs(double ******IBDprob,
		int    npedigrees,
		int    *npairs,
		double **location,
		int    *numlik,
		prs    ***pairs,
		cmd    c){

  int ntypes;


  if(c.type.par==3) ntypes=2;
  else ntypes=1;

  printf("===========================\n");
  printf("Probability of IBD sharing \n");
  printf("===========================\n");
  for(ped=0; ped < npedigrees; ped++){
    printf("pedigree %3d\n",ped+1);
    /* print out pairs */
    printf("pair: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pair+1);
    printf("\n");
    printf("mem1: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pairs[ntypes-1][ped][pair].pid[0]);
    printf("\n");
    printf("mem2: ");
    for(pair=0; pair<npairs[ped]; pair++) 
      printf("%5d ",pairs[ntypes-1][ped][pair].pid[1]);
    printf("\n");
    for(i=1; i < c.file.nmodels; i++)
      for(j=0; j < numlik[i]; j++)
        for(ibd=0; ibd < 3; ibd++){
          printf("%5.2lf (%1d)", 100*location[i][j],ibd);
          for(pair=0; pair<npairs[ped]; pair++) 
	    printf("%le ", IBDprob[i-1][j][ntypes-1][ped][pair][ibd]);
	  printf("\n");
        }
  }

} 

