/***************************************************************

  Program: SIMPLE 
  File:    GetCutPeelPedIndex.c
  Author:  Zachary Skrivanek 
  Date:    January 26, 2002 
  Purpose: Get corresponding pedigree indices for members in 
	   cut and peel sets.

***************************************************************/

#include <stdio.h>
#include "simple.h" /* c */

#define PID 0

count   i,j,ped,peel;
sindex  *c,*p;

void  GetCutPeelPedIndex(int     npedigrees,
                         int     ***pedigree,
		         int     *pedigreesize,
		         int     *npeels,
		         sindex  **cutset, 
		         sindex  **peelset){

  for(ped=0; ped < npedigrees; ped++)
    for(peel=0; peel < npeels[ped]; peel++){
      c = &cutset[ped][peel];
      p = &peelset[ped][peel];
      for(i=0; i < c->n; i++)
        for(j=0; j < pedigreesize[ped]; j++)
	  if(c->pid[i]==pedigree[ped][j][PID]){
	    c->ped[i]=j;
            break;
          }
      for(i=0; i < p->n; i++)
        for(j=0; j < pedigreesize[ped]; j++)
	  if(p->pid[i]==pedigree[ped][j][PID]){
	    p->ped[i]=j;
            break;
          }
    }
}

void  DebugGetCutPeelPedIndex(int     npedigrees,
                              int     *npeels,
                              sindex  **cutset, 
                              sindex  **peelset){

  char response[2];

  printf("\n\nDebug GetCutPeelPedIndex()? => ");
  scanf("%s", response);
  if(strcmp(response, "q") == 0) exit(0);
  if(strcmp(response, "y") == 0)
  {
    printf("\n\n");
    for(ped=0; ped < npedigrees; ped++){
      printf("ped %2d\n",ped+1);
      printf("******\n");
      for(peel=0; peel<npeels[ped]; peel++){
        c = &cutset[ped][peel];
        p = &peelset[ped][peel];
        printf("%2d:  Cut:  ",peel+1);
        for(i=0; i<c->n; i++)
          printf("%d(%3d) ",c->pid[i],c->ped[i]);
        if(peel==npeels[ped]-1) printf("ROOT ");
        printf(" Peel:  ");
        for(i=0; i < p->n; i++)
          printf("%d(%3d) ",p->pid[i],p->ped[i]);
        printf("\n");
      }
    }
  }
}




