/* *****************************************************************************

   Program:   mlla (multi-locus linkage analysis)
   File:      condprob.c
   Author:    Mark E. Irwin
   Date:      July 29, 1992
   Purpose:   Calculates conditional probabililities of inheriting
	      allele from a parent given ibd vector.
   Modified:  September 1, 2002.  made prob a one dim array instead of two 
   	      dimensional array

*************************************************************************** */

#include <stdio.h>

double condprob(int ma,
		int mF,
		int mM,
		int nloci,
		int locus,
		int *ibd,
		double *prob)
{
  int unbase();
  int m,n;

  if ((ma == mF) && (ma == mM)) return(1.0);
  else if ((ma != mF) && (ma != mM)) return(0.0);
  else {
    m = unbase(nloci,3,ibd);
    if (ma == mF) n = m - ibd[locus]*power(3,locus);
    else n = m + (1 - ibd[locus])*power(3,locus);
    if(prob[m]==0.0) 
      return(0.0);
    else
      return(prob[n]/prob[m]);
  }
}
