/* ***************************************************************************

   Program:   mlla (multi-locus linkage analysis)
   File:      dumpibds.c
   Author:    Mark E. Irwin
   Date:      Oct 21, 1992
   Purpose:   Writes out the ibds in coded format (m=sum(zi*3^i)) for
	      all people in each simulation   

*************************************************************************** */

#include <stdio.h>

#define F 0
#define M 1
#define FOUNDER 0

void DumpIBDS(int npedigrees,
	      int *pedigreesize,
	      int ***ancestry,
	      int nloci,
	      int ****ibd,
	      int *locusorder)

{
  int i,j,k;
  int mf,mm;

  for(i=0; i<npedigrees; i++)
    for(j=0; j<pedigreesize[i]; j++) {
      if(!ancestry[i][j][FOUNDER]) {  
         mf = ibd[i][j][locusorder[nloci-1]-1][F];
         for(k=nloci-2; k>=0; k--)
           mf = mf*3 + ibd[i][j][locusorder[k]-1][F];
         printf(" %d",mf);
      }
    }
 
  for(i=0; i<npedigrees; i++)
    for(j=0; j<pedigreesize[i]; j++) {
      if(!ancestry[i][j][FOUNDER]){ 
         mm = ibd[i][j][locusorder[nloci-1]-1][M];
         for(k=nloci-2; k>=0; k--)
           mm = mm*3 + ibd[i][j][locusorder[k]-1][M];
         printf(" %d",mm);
      } 
    }
  printf(" ");
}



