/* ***************************************************************************


   Program:   mlla (multi-locus linkage analysis)
   File:      ibdblank.c
   Author:    Mark E. Irwin
   Date:      October 6, 1992
   Purpose:   Blanks out ibds for one locus.

*************************************************************************** */

#include <stdio.h>

#define F 0
#define M 1

void IBDBlank(int npedigrees,
	      int *pedigreesize,
	      int locus,
	      int ****ibd)

{
  int i,j;
  for(i=0; i<npedigrees; i++)
    for(j=0; j<pedigreesize[i]; j++) {
        ibd[i][j][locus][F] = 2;
        ibd[i][j][locus][M] = 2;
    }
}
