/* ***************************************************************************


   Program:   mlla (multi-locus linkage analysis)
   File:      ibdreset.c
   Author:    Mark E. Irwin
   Date:      October 6, 1992
   Purpose:   Resets IBD to observed values for one locus

*************************************************************************** */

#include <stdio.h>

#define F 0
#define M 1

void IBDReset(int npedigrees,
	      int *pedigreesize,
	      int locus,
	      int ****ibdsim,
	      int ****ibdobs)

{
  int i,j;

  for(i=0; i<npedigrees; i++)
    for(j=0; j<pedigreesize[i]; j++) {
      ibdsim[i][j][locus][F] = ibdobs[i][j][locus][F];
      ibdsim[i][j][locus][M] = ibdobs[i][j][locus][M];
    }
}
