/* modified Nov 20, 2001 to convert cM to M */

void recomb_pp(int m,double *d,double *prob,int nloci)
{
  double *x;                     
  double sum,sum1;   /*sum is used to calculate the sum of all matrix entries*/
  double *amat;  /* pointer to all the matrices*/
  double *u;
  double *prod,*init,*excha;/*pointer to the mat used to compute the product*/
  int nrecomb;
  int k,i,j,k1,k2,p,n, **recomb_pat, *c2;
  int ipattern,jrecomb;
  

  double *dvector();
  void free_dvector(),free_ivector();
  int *ivector();
  int **imatrix();
  void matprod();
  void allmat();
  void basen();

  n = nloci-1;
  p=m+1;
/* allocate space */
  nrecomb = power(2,n);
  x = dvector(0,n);
  prod = dvector(0,p*p-1);
  init = dvector(0,p*p-1);
  amat = dvector(0,n*2*p*p-1);
  recomb_pat = imatrix(0,nrecomb,0,n);
  c2 = ivector(0,nloci);

/* change cM to M */
  for(i=0; i<n; i++)
    d[i] /= 100.0;

  for (i=0; i<nrecomb; i++)
  {
    ipattern=i;
    jrecomb=nrecomb/2;
    for (j=(nloci-2); j>=0; j--)
    {
      recomb_pat[i][j]=ipattern/jrecomb;
      ipattern %=jrecomb;
      jrecomb /= 2;
    }
  }


/* we order the recomb_pat to correspond to Mark's program */
/* go back to the original ordering 
  for (i=0; i<nrecomb; i++)
  {
    basen(nloci,2,i,c2);
    for (j=0; j<n; j++)
    {
      if(c2[j] == c2[j+1])
        recomb_pat[i][j] = 0;
      else
        recomb_pat[i][j] = 1;
    }
  }
*/

  for (i=0; i<(nloci-1); i++) x[i]=(*(d+i))*2*(m+1);
  
  u = x; /* Make the pointer point to the estimated parameter value */
  sum1 = 0.0;

  allmat(n,p,u,amat);  /* Calculating all 2*n matrices */
 
  for (i=0; i<nrecomb; i++)  /* Initilaize the init as Identity matrix */
  {        
    for (k1=0;k1<p;k1++)
    {
      for (k2=0;k2<p;k2++)
      {
	if (k1==k2)
          *(init+k1*p+k2) = 1.0;
        else
          *(init+k1*p+k2) = 0.0;
      }
    }
		       
    for (j=0;j<n;j++)
    {
      matprod(init,amat+2*j*p*p+(1-recomb_pat[i][j])*p*p,prod,p,p,p);
      excha = init;
      init = prod;
      prod = excha;
    }

    sum = 0.0;
    for (k1=0;k1<p*p;k1++)
    {
      init[k1] = init[k1]/((double) p);
      sum += *(init+k1);
    }
    prob[i]=sum;

 }
 free_dvector(amat,0,2*n*p*p-1);
 free_dvector(prod,0,p*p-1);
 free_dvector(init,0,p*p-1);
}
