/* ***************************************************************************


   Program:   mlla (multi-locus linkage analysis)
   File:      simblank.c
   Author:    Mark E. Irwin
   Date:      August 17, 1992
   Purpose:   Blanks out simulated ibds from designated parts of the
	      pedigree.   

*************************************************************************** */

#include <stdio.h>

#define F 0
#define M 1

void SimBlank(int npedigrees,
	      int *pedigreesize,
	      int locus,
	      int ***blank,
	      int ****ibdsim)

{
  int i,j;

  for(i=0; i<npedigrees; i++)
    for(j=0; j<pedigreesize[i]; j++)
      if(blank[i][j][locus]) {
        ibdsim[i][j][locus][F] = 2;
        ibdsim[i][j][locus][M] = 2;
      }
}
