/* ************************************************************

   Program:   simple (Sequential Imputation for Multi-Point Linkage
              Estimation)
   File:      simple.h
   Author:    Zachary Skrivanek 
   Date:      September 2, 2000 
   Purpose:   header file for simple 

************************************************************* */

#define  bool int 
#define  count int 

struct  affstatus{
  int    status;
  int    class;
};

typedef  struct affstatus aff;

struct  cword{
  char   *par;
  bool   def;
};

typedef struct cword cword; 

struct  cwords{
  char   **fname;
  bool   par;
  bool   def;
};

typedef struct cwords cwords; 

struct  cint{
  int    par;
  bool   def;
};

typedef struct cint cint; 

struct  cbool{
  bool   par;
  bool   def;
};

typedef struct cbool cbool; 

struct  cdouble{
  double par;
  bool   def;
};

typedef struct cdouble cdouble; 

struct  cinterference{
  int    model;
  int    par;
  bool   def;
};

typedef struct cinterference cinterf; 


struct  cfile{
  char   *par;
  int    nmodels;
  bool   def;
};

typedef struct cfile cfile; 

struct  pairs{
  int    pid[2];
  int	 index[2];
  double pheno;
};

typedef struct pairs prs; 


struct  sindex{
  int    *pid; 
  int	 *ped; 
  int    n;
};

typedef struct sindex sindex; 


struct  tindex{
  int	 set[3]; 
  int	 ped[3]; 
};

typedef struct tindex tindex; 


struct  Rindex{
  int    *pid; 
  int	 *set; 
  int    n;
  int    r;
};

typedef struct Rindex Rindex; 


struct  cporder{
  int    *par;
  bool   def;
};

typedef struct cporder cporder; 


struct  commands{
          cword   load;
          cword   load2;
          cword   scan; 
          cword   score; 
          cword   pen;
          cword   analysis; 
          cint    maxiter;
          cint    nsteps;
          cint    seed;
          cbool   debug;
          cbool   wstar;
          cbool   fixaffected;
          cbool   reweight;
          cbool   dumplikrats;
          cbool   dumpscores;
          cbool   dumpdata;
          cbool   hasemanelston;
          cinterf interference;    
          cfile   file;          
          cbool   dumpibd;
          cbool   dumphap;
          cporder processorder;
	  cbool   total_stat;
          cbool   sim;  
	  cint    whichQT;	
	  cword   units;
	  cdouble missingQT;
	  cint    diseaseloc;
	  cint    diseaseloc2;
          cwords  peel; 
          cbool   joint;
	  double  dis;
	  cint    type;
          cbool   dumppairs;
          cbool   dumpprobs;
};

typedef struct commands cmd;
